#ifndef __X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H
#define __X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
#define X10_LANG_ITERATOR_H_NODEPS
#include <x10/lang/Iterator.h>
#undef X10_LANG_ITERATOR_H_NODEPS
#define X10_LANG_INT_H_NODEPS
#include <x10/lang/Int.h>
#undef X10_LANG_INT_H_NODEPS
namespace x10 { namespace array { 
template<class TPMGL(T31869)> class Array__Anonymous__13465;
} } 
namespace x10 { namespace lang { 
class Int;
} } 
namespace x10 { namespace util { 
template<class TPMGL(T)> class IndexedMemoryChunk;
} } 
namespace x10 { namespace array { 
template<class TPMGL(T)> class Array;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace array { 

template<class TPMGL(T31870)> class Array__Anonymous__13465__Anonymous__13522;
template <> class Array__Anonymous__13465__Anonymous__13522<void>;
template<class TPMGL(T31870)> class Array__Anonymous__13465__Anonymous__13522 : public x10::lang::Object
  {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::itable_entry _itables[3];
    
    virtual x10aux::itable_entry* _getITables() { return _itables; }
    
    static typename x10::lang::Iterator<TPMGL(T31870)>::template itable<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > _itable_0;
    
    static x10::lang::Any::itable<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > _itable_1;
    
    x10aux::ref<x10::array::Array__Anonymous__13465<TPMGL(T31870)> >
      FMGL(out__);
    
    x10_int FMGL(cur);
    
    virtual TPMGL(T31870) next();
    virtual x10_boolean hasNext();
    void _constructor(x10aux::ref<x10::array::Array__Anonymous__13465<TPMGL(T31870)> > out__);
    
    static x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > _make(
             x10aux::ref<x10::array::Array__Anonymous__13465<TPMGL(T31870)> > out__);
    
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};
template <> class Array__Anonymous__13465__Anonymous__13522<void> : public x10::lang::Object
{
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H

namespace x10 { namespace array { 
template<class TPMGL(T31870)> class Array__Anonymous__13465__Anonymous__13522;
} } 

#ifndef X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_NODEPS
#define X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_NODEPS
#include <x10/lang/Object.h>
#include <x10/lang/Iterator.h>
#include <x10/array/Array__Anonymous__13465.h>
#include <x10/lang/Int.h>
#include <x10/util/IndexedMemoryChunk.h>
#include <x10/array/Array.h>
#include <x10/lang/Boolean.h>
#ifndef X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_GENERICS
#define X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_GENERICS
#endif // X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_GENERICS
#ifndef X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_IMPLEMENTATION
#define X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_IMPLEMENTATION
#include <x10/array/Array__Anonymous__13465__Anonymous__13522.h>

template<class TPMGL(T31870)> typename x10::lang::Iterator<TPMGL(T31870)>::template itable<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >  x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_itable_0(&x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::equals, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::hasNext, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::hashCode, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::next, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::toString, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::typeName);
template<class TPMGL(T31870)> x10::lang::Any::itable<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >  x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_itable_1(&x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::equals, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::hashCode, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::toString, &x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::typeName);
template<class TPMGL(T31870)> x10aux::itable_entry x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_itables[3] = {x10aux::itable_entry(&x10aux::getRTT<x10::lang::Iterator<TPMGL(T31870)> >, &_itable_0), x10aux::itable_entry(&x10aux::getRTT<x10::lang::Any>, &_itable_1), x10aux::itable_entry(NULL, (void*)x10aux::getRTT<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >())};

//#line 372 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10FieldDecl_c

//#line 374 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10FieldDecl_c

//#line 375 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(T31870)> TPMGL(T31870) x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::next(
  ) {
    
    //#line 375 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10Return_c
    return (x10aux::nullCheck(x10aux::nullCheck(((x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >)this)->
                                                  FMGL(out__))->
                                FMGL(out__))->FMGL(raw))->__apply(((x10_int) (((__extension__ ({
        
        //#line 375 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10LocalDecl_c
        x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > x32012 =
          ((x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >)this);
        
        //#line 375 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": polyglot.ast.Empty_c
        ;
        x10aux::nullCheck(x32012)->FMGL(cur) = ((x10_int) ((x10aux::nullCheck(x32012)->
                                                              FMGL(cur)) + (((x10_int)1))));
    }))
    ) - (((x10_int)1)))));
    
}

//#line 376 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(T31870)> x10_boolean x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::hasNext(
  ) {
    
    //#line 376 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10Return_c
    return ((((x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >)this)->
               FMGL(cur)) < ((x10aux::nullCheck(x10aux::nullCheck(((x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >)this)->
                                                                    FMGL(out__))->
                                                  FMGL(out__))->
                                FMGL(raw))->length()));
    
}

//#line 373 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10ConstructorDecl_c
template<class TPMGL(T31870)> void x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_constructor(
                                x10aux::ref<x10::array::Array__Anonymous__13465<TPMGL(T31870)> > out__) {
    
    //#line 373 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": x10.ast.X10ConstructorCall_c
    (this)->::x10::lang::Object::_constructor();
    
    //#line 372 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/array/Array.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >)this)->
      FMGL(out__) = out__;
}
template<class TPMGL(T31870)> x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_make(
                                x10aux::ref<x10::array::Array__Anonymous__13465<TPMGL(T31870)> > out__)
{
    x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > this_ = new (memset(x10aux::alloc<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >(), 0, sizeof(x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>))) x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>();
    this_->_constructor(out__);
    return this_;
}


template<class TPMGL(T31870)> const x10aux::serialization_id_t x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_serialization_id = 
    x10aux::DeserializationDispatcher::addDeserializer(x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_deserializer, x10aux::CLOSURE_KIND_NOT_ASYNC);

template<class TPMGL(T31870)> void x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_serialize_body(x10aux::serialization_buffer& buf) {
    x10::lang::Object::_serialize_body(buf);
    buf.write(this->FMGL(cur));
    buf.write(this->FMGL(out__));
    
}

template<class TPMGL(T31870)> x10aux::ref<x10::lang::Reference> x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_deserializer(x10aux::deserialization_buffer& buf) {
    x10aux::ref<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> > this_ = new (memset(x10aux::alloc<x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)> >(), 0, sizeof(x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>))) x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>();
    buf.record_reference(this_);
    this_->_deserialize_body(buf);
    return this_;
}

template<class TPMGL(T31870)> void x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_deserialize_body(x10aux::deserialization_buffer& buf) {
    x10::lang::Object::_deserialize_body(buf);
    FMGL(cur) = buf.read<x10_int>();
    FMGL(out__) = buf.read<x10aux::ref<x10::array::Array__Anonymous__13465<TPMGL(T31870)> > >();
}

template<class TPMGL(T31870)> x10aux::RuntimeType x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::rtt;
template<class TPMGL(T31870)> void x10::array::Array__Anonymous__13465__Anonymous__13522<TPMGL(T31870)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::array::Array__Anonymous__13465__Anonymous__13522<void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[2] = { x10aux::getRTT<x10::lang::Object>(), x10aux::getRTT<x10::lang::Iterator<TPMGL(T31870)> >()};
    const x10aux::RuntimeType* params[1] = { x10aux::getRTT<TPMGL(T31870)>()};
    x10aux::RuntimeType::Variance variances[1] = { x10aux::RuntimeType::invariant};
    const char *baseName = "x10.array.Array.Anonymous.13465.Anonymous.13522";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::class_kind, 2, parents, 1, params, variances);
}
#endif // X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_IMPLEMENTATION
#endif // __X10_ARRAY_ARRAY__ANONYMOUS__13465__ANONYMOUS__13522_H_NODEPS
